constant
  NE = 1,
  SE = 2,
  SW = 3,
  NW = 4

atom xpos, ypos, handle, xvector, yvector
integer kind, status, life, animate, size, flag, atx, aty
integer idealface, facing, turn, visibility
sequence s, pathpoint

procedure DoTurn()
          if facing = idealface then
          elsif idealface > facing then
            if idealface < facing + 12 then
              if turn = 3 then
                turn = 1
                if facing = 24 then
                  facing = 1
                else
                  facing += 1
                end if
              else
                turn += 1
              end if
            else
              if turn = 1 then
                turn = 3
                if facing = 1 then
                  facing = 24
                else
                  facing -= 1
                end if
              else
                turn -= 1
              end if
            end if
          else
            if idealface > facing - 12 then
              if turn = 1 then
                turn = 3
                if facing = 1 then
                  facing = 24
                else
                  facing -= 1
                end if
              else
                turn -= 1
              end if
            else
              if turn = 3 then
                turn = 1
                if facing = 24 then
                  facing = 1
                else
                  facing += 1
                end if
              else
                turn += 1
              end if
            end if
          end if
end procedure

procedure SetVector(integer c)
  if actors[c][STRAFE] then
    if actors[c][STRAFE] = NW then
      xvector = step_left_vector[facing+3][XPOS]
      yvector = step_left_vector[facing+3][YPOS]
    elsif actors[c][STRAFE] = NE then
      xvector = step_right_vector[facing+21][XPOS]
      yvector = step_right_vector[facing+21][YPOS]
    elsif actors[c][STRAFE] = RIGHT then
      xvector = step_right_vector[facing][XPOS]
      yvector = step_right_vector[facing][YPOS]
    else -- LEFT
      xvector = step_left_vector[facing][XPOS]
      yvector = step_left_vector[facing][YPOS]
    end if
  else
    DoTurn()
    if kind = halfdead then
      yvector = vector0_5[facing][YPOS]
      xvector = vector0_5[facing][XPOS]
    else  
      yvector = vector1[facing][YPOS]
      xvector = vector1[facing][XPOS]
    end if
  end if
end procedure

procedure ChkCrash(integer c)
    xpos += xvector
    ypos += yvector
    size = sizes[kind][XPOS]
    hitflag = 0
    if Actor(floor(xpos), floor(ypos), size, c)
      or Wall(xpos, ypos, size, walkover)
      or Door(floor(xpos), floor(ypos), size)
    then
      xpos -= xvector

      if hitflag = 2 and find(kind,{undead,halfdead}) then
        if (kind = undead and integer(animate/2)) or
           (kind = halfdead and integer(animate/4)) then
          Hlife -= 1
          text_line({1,1}, back_vs, sprintf("%3d",Hlife))
        end if
      end if

      if Wall(xpos, ypos, size, walkover)
        or Actor(floor(xpos), floor(ypos), size, c)
        or Door(floor(xpos), floor(ypos), size)
      then
        xpos += xvector
        ypos -= yvector
        if Wall(xpos, ypos, size, walkover)
          or Actor(floor(xpos), floor(ypos), size, c)
          or Door(floor(xpos), floor(ypos), size)
        then
          xpos -= xvector
          if not hitflag and not actors[c][STRAFE] then
            if facing = idealface then
              flag = 2
            end if
          end if
        end if
      end if

      if not hitflag and not actors[c][STRAFE] then
        if facing = idealface and find(facing,{1,7,13,19}) then
          flag = 1
        end if
      end if

    end if

  if actors[c][STRAFE] then
    actors[c][TIMER] -= 1
    if actors[c][TIMER] = 0 then
      actors[c][STRAFE] = 0
    end if
  end if
end procedure

procedure ChkStrafe(integer c)
if flag=1 then
  atx = floor(xpos/20) + 1
  aty = floor(ypos/20) + 1

  if (facing = 1 and LVL_WALK[aty-1][atx+1]) or
  (facing = 7 and LVL_WALK[aty+1][atx+1]) or
  (facing = 13 and LVL_WALK[aty+1][atx]) or
  (facing = 19 and LVL_WALK[aty][atx-1]) then
    actors[c][STRAFE] = NE
    actors[c][TIMER] = 25
  elsif (facing = 1 and LVL_WALK[aty-1][atx]) or
  (facing = 7 and LVL_WALK[aty][atx+1]) or
  (facing = 13 and LVL_WALK[aty+1][atx+1]) or
  (facing = 19 and LVL_WALK[aty+1][atx-1]) then
    actors[c][STRAFE] = NW
    actors[c][TIMER] = 25
  elsif (facing = 1 and LVL_WALK[aty-1][atx+2]) or
  (facing = 7 and LVL_WALK[aty+2][atx+1]) or
  (facing = 13 and LVL_WALK[aty+1][atx-1]) or
  (facing = 19 and LVL_WALK[aty-1][atx-1]) then
    actors[c][STRAFE] = NE
    actors[c][TIMER] = 50
  elsif (facing = 1 and LVL_WALK[aty-1][atx-1]) or
  (facing = 7 and LVL_WALK[aty-1][atx+1]) or
  (facing = 13 and LVL_WALK[aty+1][atx+2]) or
  (facing = 19 and LVL_WALK[aty+2][atx-1]) then
    actors[c][STRAFE] = NW
    actors[c][TIMER] = 50
  end if
elsif flag = 2 then
  atx = floor(xpos/20) + 1
  aty = floor(ypos/20) + 1
  if find(facing, {2,3,4,5,6}) then
    flag = NE
  elsif find(facing, {8,9,10,11,12}) then
    flag = SE
  elsif find(facing, {14,15,16,17,18}) then
    flag = SW
  elsif find(facing, {20,21,22,23,24}) then
    flag = NW
  end if

    if (flag = NE and LVL_WALK[aty+1][atx+1]) or
    (flag = SE and LVL_WALK[aty+1][atx-1]) or
    (flag = SW and LVL_WALK[aty-1][atx-1]) or
    (flag = NW and LVL_WALK[aty-1][atx+1]) then
      actors[c][STRAFE] = RIGHT
      actors[c][TIMER] = 35
    elsif (flag = NE and LVL_WALK[aty-1][atx-1]) or
    (flag = SE and LVL_WALK[aty-1][atx+1]) or
    (flag = SW and LVL_WALK[aty+1][atx+1]) or
    (flag = NW and LVL_WALK[aty+1][atx-1]) then
      actors[c][STRAFE] = LEFT
      actors[c][TIMER] = 35
    elsif (flag = NE and LVL_WALK[aty+2][atx+1]) or
    (flag = SE and LVL_WALK[aty+1][atx-2]) or
    (flag = SW and LVL_WALK[aty-2][atx-1]) or
    (flag = NW and LVL_WALK[aty+2][atx-1]) then
      actors[c][STRAFE] = RIGHT
      actors[c][TIMER] = 70
    elsif (flag = NE and LVL_WALK[aty-1][atx-2]) or
    (flag = SE and LVL_WALK[aty-2][atx+1]) or
    (flag = SW and LVL_WALK[aty+1][atx+2]) or
    (flag = NW and LVL_WALK[aty+2][atx-1]) then
      actors[c][STRAFE] = LEFT
      actors[c][TIMER] = 70
    end if
end if
end procedure

global procedure MoveActors()
  for c = 1 to length(actors) do
    if sequence(actors[c]) then
      s = actors[c]
      handle = s[HANDLE]
      xpos = s[XPOS]
      ypos = s[YPOS]
      life = s[LIFE]
      kind = s[KIND]
      flag = 0

      if life < 1 and kind = undead then
        actors[c][KIND] = halfdead
        --kind = halfdead
        actors[c][LIFE] = 20
          xpos = floor(xpos)-3
          ypos = floor(ypos)
          AddBlood(xpos+6,ypos)
          AddBlood(xpos+12,ypos)
          AddBlood(xpos,ypos+6)
          AddBlood(xpos+6,ypos+6)
          AddBlood(xpos+12,ypos+6)
          AddBlood(xpos,ypos+12)
          AddBlood(xpos+6,ypos+12)
          AddBlood(xpos+12,ypos+12)
          for z = 1 to 3 do
            AddBlood(xpos-3+rand(16),ypos-3+rand(16))
          end for
      elsif life < 1 then
        free_command(handle)
        if kind = barrel then
          AddExplosion(xpos-2,ypos-21,0)
          AddExplosion(xpos+9,ypos-14,0)
          AddExplosion(xpos+16,ypos-2,0)
          AddExplosion(xpos+9,ypos+9,0)
          AddExplosion(xpos-2,ypos+16,0)
          AddExplosion(xpos-14,ypos+9,0)
          AddExplosion(xpos-21,ypos-2,0)
          AddExplosion(xpos-14,ypos-14,0)
          AddExplosion(xpos-2,ypos-2,0)
        elsif kind = car then
          AddExplosion(xpos-2,ypos-2,0)
          AddExplosion(xpos-2,ypos+18,0)
          AddExplosion(xpos-2,ypos+38,0)
          AddExplosion(xpos+18,ypos-2,0)
          AddExplosion(xpos+18,ypos+18,0)
          AddExplosion(xpos+18,ypos+38,0)
        elsif kind = tv or kind = pc then
          AddExplosion(xpos-2,ypos-2,0)
          if kind = tv then
            AddStash(xpos,ypos,breakwood)
          else
            AddStash(xpos,ypos,breakmetal)
          end if
        elsif kind = windowhor then
          AddStash(xpos,ypos-8,windowhorbreak)
        elsif kind = windowver then
          AddStash(xpos-8,ypos,windowverbreak)
        elsif kind = bottle then
        elsif find(kind,{chair}) then
          AddStash(xpos,ypos,breakwood)
        elsif find(kind,{washbasin, toilet, locker}) then
          AddStash(xpos,ypos,breakmetal)
        else
          xpos = floor(xpos)-3
          ypos = floor(ypos)
          AddBlood(xpos+6,ypos)
          AddBlood(xpos+12,ypos)
          AddBlood(xpos,ypos+6)
          AddBlood(xpos+6,ypos+6)
          AddBlood(xpos+12,ypos+6)
          AddBlood(xpos,ypos+12)
          AddBlood(xpos+6,ypos+12)
          AddBlood(xpos+12,ypos+12)
          for z = 1 to 3 do
            AddBlood(xpos-3+rand(16),ypos-3+rand(16))
          end for
          if length(s) = 14 and s[CARRY] then
            kind = s[CARRY]
            if kind = 58 then -- blue keycard
              s = {5,1}
            elsif kind = 59 then -- red keycard
              s = {5,2}
            elsif kind = 60 then -- yellow keycard
              s = {5,3}
            elsif kind = 63 then -- gunammo
              s = {16,1}
            elsif kind = 64 then -- shotgunammo
              s = {17,1}
            elsif kind = 65 then -- whisky
              s = {21,1}
            elsif kind = 66 then -- medikit
              s = {21,2}
            end if
            GetActors({3,xpos+4,ypos+1,s,0})
          end if
        end if
        actors[c] = 0
      else
      
        status = s[STATUS]
        if status = STATIC then

        elsif status = STATIC_ANIMATE then
          kind = s[KIND]
          animate = s[ANIMATE]
          if animate = length(sprites[kind]) then
            animate = 1
          else
            animate += 1
          end if
          set_source_handle(handle, sprites[kind][animate])
          actors[c][ANIMATE] = animate
        elsif status = STATIC_FACE_ANIMATE then
          kind = s[KIND]
          animate = s[ANIMATE]
          facing = s[FACING]
          if animate = length(sprites[kind][facing]) then
            animate = 1
          else
            animate += 1
          end if
          set_source_handle(handle, sprites[kind][facing][animate])
          actors[c][ANIMATE] = animate
        elsif status = WAIT then
          kind = s[KIND]
          if Los(xpos + 8, ypos + 8, Hxpos + 8, Hypos + 8) then
            if find(kind, {sitter,guntower}) then
              actors[c][STATUS] = AIM
            else
              actors[c][STATUS] = HUNTER
            end if
          end if
        elsif status = AIM then
          kind = s[KIND]
          facing = s[FACING]
          turn = s[TURN]
          animate = s[ANIMATE]
          
          idealface = GetFace({xpos, ypos}, {Hxpos, Hypos})
          DoTurn()

          if animate = length(sprites[kind][facing]) then
            animate = 1
          else
            animate += 1
          end if
          
          if kind = sitter then
            if actors[c][TIMER] = 14 then
            --if rand(SITTER_ROF) = 1 then
              AddBullet(c)
              actors[c][TIMER] = 1
            else
              actors[c][TIMER] += 1
            end if
          elsif kind = guntower then
            if find(animate, {1,10}) then
              AddBullet(c)
            end if
          end if

          actors[c][FACING] = facing
          actors[c][TURN] = turn
          actors[c][ANIMATE] = animate
          set_source_handle(handle, sprites[kind][facing][animate])
        elsif status = PATROL then
          kind = s[KIND]
          facing = s[FACING]
          turn = s[TURN]
          animate = s[ANIMATE]

          -- get idealface based on next pathpoint:
          pathpoint = s[PATH][s[PATHPOINT]]
          idealface = GetFace({xpos, ypos}, pathpoint*20-20)
          --move in same way as HUNTER:
          SetVector(c)
          ChkCrash(c)
          ChkStrafe(c)
          -- if pathpoint is reached, set next pathpoint as active:
          if HitPoint(c, pathpoint) then
            if s[PATHPOINT] = length(s[PATH]) then
               actors[c][PATHPOINT] = 1
            else
               actors[c][PATHPOINT] += 1
            end if
          end if
          -- if the actor has LOS to Hayes, then set status to HUNTER
          if Los(xpos, ypos, Hxpos, Hypos) then
            idealface = GetFace({xpos, ypos}, {Hxpos, Hypos}) - facing
            if idealface < 7 and idealface > - 7 then
              -- if within certain distance then
              actors[c][STATUS] = HUNTER
            end if
          end if

          if animate = length(sprites[kind][facing]) then
            animate = 1
          else
            animate += 1
          end if

          actors[c][FACING] = facing
          actors[c][TURN] = turn
          actors[c][ANIMATE] = animate
          actors[c][XPOS] = xpos
          actors[c][YPOS] = ypos
          set_source_handle(handle, sprites[kind][facing][animate])
        elsif status = HUNTER then
          kind = s[KIND]
          facing = s[FACING]
          turn = s[TURN]
          animate = s[ANIMATE]

          idealface = GetFace({xpos, ypos}, {Hxpos, Hypos})
          SetVector(c)
          ChkCrash(c)
          ChkStrafe(c)

          if animate = length(sprites[kind][facing]) then
            animate = 1
          else
            animate += 1
          end if

          if kind = grunt then
            if animate = 24 then
              AddBullet(c)
            end if
          elsif kind = thug then
            if find(animate,{16,32,48}) then
              AddBullet(c)
            end if
          elsif kind = dame then
            if find(animate,{24,48}) then
              AddBullet(c)
            end if
          elsif kind = gangster then
            if find(animate,{1,6,11,16,21}) then
              AddBullet(c)
            end if
          end if
          
          actors[c][FACING] = facing
          actors[c][TURN] = turn
          actors[c][ANIMATE] = animate
          actors[c][XPOS] = xpos
          actors[c][YPOS] = ypos
          set_source_handle(handle, sprites[kind][facing][animate])
        elsif status = SPECTRAL then -- flying ghost
          kind = s[KIND]
          facing = s[FACING]
          turn = s[TURN]
          animate = s[ANIMATE]

          visibility = s[VISIBILITY]
          if not visibility then
            visibility = 80
            set_mixtable(handle,FAIR_MIX)
          else
             visibility -= 1
             if visibility = 60 then
               set_mixtable(handle,DOMINANT_MIX)
             elsif visibility = 50 then
               set_mixtable(handle,FAIR_MIX)
             elsif visibility = 30 then
               set_mixtable(handle,RECESSIVE_MIX)
             end if
           end if

          if not(s[TIMER]) then
            idealface = GetFace({xpos, ypos}, {Hxpos, Hypos})
            DoTurn()
          else
            actors[c][TIMER] -= 1
          end if
          yvector = vector3[facing][YPOS]
          xvector = vector3[facing][XPOS]
          xpos += xvector
          ypos += yvector


          if animate = length(sprites[kind][facing]) then
            animate = 1
          else
            animate += 1
          end if

          actors[c][FACING] = facing
          actors[c][TURN] = turn
          actors[c][ANIMATE] = animate
          actors[c][XPOS] = xpos
          actors[c][YPOS] = ypos
          actors[c][VISIBILITY] = visibility

          size = sizes[kind][XPOS]

          if Hxpos <= xpos + size and
             xpos <= Hxpos + 17 and
             Hypos <= ypos + size and
             ypos <= Hypos + 17 then
            actors[c][TIMER] = 15
            Hlife -= rand(2)
            text_line({1,1}, back_vs, sprintf("%3d",Hlife))
            if integer(visibility/2) then
              AddBlood(floor(xpos)+5,floor(ypos)+5)
            end if
          end if

          set_source_handle(handle, sprites[kind][facing][animate])

        elsif status = BOSS then
          kind = s[KIND]
          animate = s[ANIMATE]

          if animate = length(sprites[kind]) then
            animate = 1
          else
            animate += 1
          end if

          if find(animate, {1}) then
            --Add moving explosion
          end if

          actors[c][ANIMATE] = animate
        end if -- status = ??
        set_dest_pos(handle, {xpos-scrollx, ypos-scrolly})
      end if
    end if
  end for
end procedure
