global function HitPoint(integer who, sequence point)
  integer ax, ay, size, x, y
  if who then
    ax = floor(actors[who][XPOS])
    ay = floor(actors[who][YPOS])
    size = sizes[actors[who][KIND]][XPOS]
  else
    ax = Hxpos
    ay = Hypos
    size = 17
  end if
  x = point[XPOS] * 20 - 20
  y = point[YPOS] * 20 - 20
  if ax <= x + 19 and
  x <= ax + size and
  ay <= y + 19 and
  y <= ay + size then
     return 1
  else
    return 0
  end if
end function

global function Wall(atom x, atom y, integer size, integer allowed)
  for count_y = floor(y/20)+1 to floor((y+size)/20)+1 do
    for count_x = floor(x/20)+1 to floor((x+size)/20)+1 do
      if level[count_y][count_x] > allowed then
        return 1
      end if
    end for
  end for
  return 0
end function

global function WallS(atom x, atom y, integer allowed)
  if level[floor(y/20)+1][floor(x/20)+1] > allowed then
    return 1
  end if
  return 0
end function

global function HitSome(atom x_, atom y_, integer who, integer allowed)
  integer kind, x, y
  atom ax,ay
  x = floor(x_)
  y = floor(y_)

  if level[floor(y/20)+1][floor(x/20)+1] > allowed then
    return 1
  end if

  for c = 1 to length(obs) do
    if sequence(obs[c]) then
      ax = obs[c][XPOS]
      ay = obs[c][YPOS]
      kind = obs[c][KIND]
      if ax <= x then
        if x <= ax + sizes[kind][XPOS] then
          if ay <= y then
            if y <= ay + sizes[kind][YPOS] then
              return 1
            end if
          end if
        end if
      end if
    end if
  end for

  if who then
    if Hxpos <= x then
      if x <= Hxpos + 17 then
        if Hypos <= y then
          if y <= Hypos + 17 then
            Hlife -= BULLETDAMAGE
            text_line({1,1}, back_vs, sprintf("%3d",Hlife))
            AddBlood(x-5,y-5)
            return 1
          end if
        end if
      end if
    end if
  end if

  for c = 1 to length(actors) do
    if c != who and sequence(actors[c]) then
      ax = floor(actors[c][XPOS])
      ay = floor(actors[c][YPOS])
      kind = actors[c][KIND]
      if ax <= x then
        if x <= ax + sizes[kind][XPOS] then
          if ay <= y then
            if y <= ay + sizes[kind][YPOS] then
              if kind != ghost or actors[c][VISIBILITY] > 30 then 
                actors[c][LIFE] -= BULLETDAMAGE
                if find(kind, BLEEDERS) then
                  AddBlood(x-5,y-5)
                end if
                if actors[c][STATUS] = WAIT then
                  if find(kind,{sitter,guntower}) then
                    actors[c][STATUS] = AIM
                  else
                   actors[c][STATUS] = HUNTER
                  end if
                elsif actors[c][STATUS] = PATROL then
                  actors[c][STATUS] = HUNTER
                end if
                return 1
              end if
            end if
          end if
        end if
      end if
    end if
  end for

  return 0
end function

global function Door(atom x_, atom y_, integer size)
  integer ax,ay,kind,x,y
  x = floor(x_)
  y = floor(y_)
  for c = 1 to length(obs) do
    if sequence(obs[c]) then
      ax = obs[c][XPOS]
      ay = obs[c][YPOS]
      kind = obs[c][KIND]
      if ax <= x + size then
        if x <= ax + sizes[kind][XPOS] then
          if ay <= y + size then
            if y <= ay + sizes[kind][YPOS] then
              hitflag = 2
              return 1
            end if
          end if
        end if
      end if
    end if
  end for
  return 0
end function

global function DoorH()
  integer ax,ay,kind
  for c = 1 to length(obs) do
    if sequence(obs[c]) then
      ax = obs[c][XPOS]
      ay = obs[c][YPOS]
      kind = obs[c][KIND]
      if ax <= Hxpos + 17 then
        if Hxpos <= ax + sizes[kind][XPOS] then
          if ay <= Hypos + 17 then
            if Hypos <= ay + sizes[kind][YPOS] then
              if kind = opendoorhor or kind = opendoorver then
                free_command(obs[c][HANDLE])
                obs[c] = 0
              elsif keys[BLUEKEY] and (kind = bluedoorhor or
                                       kind = bluedoorver) then
                free_command(obs[c][HANDLE])
                obs[c] = 0
              elsif keys[REDKEY] and (kind = reddoorhor or
                                      kind = reddoorver) then
                free_command(obs[c][HANDLE])
                obs[c] = 0
              elsif keys[YELLOWKEY] and (kind = yellowdoorhor or
                                         kind = yellowdoorver) then
                free_command(obs[c][HANDLE])
                obs[c] = 0
              else
                return 1
              end if
              ax = floor(ax/20)+1
              ay = floor(ay/20)+1
              LVL_FLY[ay][ax] = 0
            end if
          end if
        end if
      end if
    end if
  end for
  return 0
end function

global function Actor(atom x_, atom y_, integer size, integer dude)
  integer kind
  integer ax,ay, x, y
  x = floor(x_)
  y = floor(y_)
  
  if dude then
    if floor(Hxpos) <= x + size then
      if x <= floor(Hxpos) + 17 then
        if floor(Hypos) <= y + size then
          if y <= floor(Hypos) + 17 then
            hitflag = 2
            return 1
          end if
        end if
      end if
    end if
  end if
  
  for c = 1 to length(actors) do
    if c != dude and sequence(actors[c]) then
      ax = floor(actors[c][XPOS])
      ay = floor(actors[c][YPOS])
      kind = actors[c][KIND]
      if ax <= x + size then
        if x <= ax + sizes[kind][XPOS] then
          if ay <= y + size then
            if y <= ay + sizes[kind][YPOS] then
              if kind != ghost then
                hitflag = 1
                return 1
              end if
            end if
          end if
        end if
      end if
    end if
  end for
  
  return 0
end function

global function Los(atom x,atom y,atom x2,atom y2)
  integer d,dx,dy,ai,bi,xi,yi,temp
  x=floor(x/20)
  x2=floor(x2/20)
  y=floor(y/20)
  y2=floor(y2/20)
  if y=y2 then -- horizontal line
    if x>x2 then
      temp=x
      x=x2
      x2=temp
    end if
    for i=x to x2 do
      if LVL_FLY[y+1][i+1] then
        return 0
      end if
    end for
  else
    if x<x2 then
      xi=1
      dx=x2-x
    else
      xi=-1
      dx=x-x2
    end if
    if y<y2 then
      yi=1
      dy=y2-y
    else
      yi=-1
      dy=y-y2
    end if
    if LVL_FLY[y+1][x+1] then
      return 0
    end if
    if dx>dy then
      ai=2*(dy-dx)
      bi=2*dy
      d=bi-dx
      while x!=x2 do
        if d>=0 then
          y=y+yi
          d=d+ai
        else
          d=d+bi
        end if
        x=x+xi
        if LVL_FLY[y+1][x+1] then
          return 0
        end if
      end while
    else
      ai=2*(dx-dy)
      bi=2*dx
      d=bi-dy
      while y!=y2 do
        if d>=0 then
          x=x+xi
          d=d+ai
        else
          d=d+bi
        end if
        y=y+yi
        if LVL_FLY[y+1][x+1] then
          return 0
        end if
      end while
    end if
  end if
  return 1
end function
