global procedure AddStains(integer x, integer y, atom kind, atom mix)
  atom h
  h = new_command(mix_copy, kind, {levelvs,x,y,0})
  set_mixtable(h, mix)
  stains &= h
end procedure

global procedure ClearStains()
  for n = 1 to length(stains) do
    free_command(stains[n])
  end for
  stains = {}
end procedure

global procedure AddExplosion(atom x_, atom y_, object v)
  integer i, x, y
  atom h
  sequence s
  x = floor(x_)
  y = floor(y_)
  h = new_command(mix_copy,sprites[explosion][1],{action_vs,x,y,6})
  set_mixtable(h,DOMINANT_MIX)
  if sequence(v) then
    s = {x,y,explosion,h,MOVING,0,v[1],v[2]}
  else
    s = {x,y,explosion,h,STATIC_ANIMATE,0}
  end if
  i = find(0,effects)
  if i then
    effects[i] = s
  else
    effects = append(effects,s)
  end if
end procedure

global procedure AddStash(integer x, integer y, integer kind)
  atom h
  integer i
  h = new_command(mix_copy, sprites[kind][1], {action_vs,x,y,2})
  set_mixtable(h,DOMINANT_MIX)
  i = find(0,effects)
  if i then
    effects[i] = {x, y, kind, h, BLOOD, 0}
  else
    effects &= {{x,y,kind,h,BLOOD,0}}
  end if
end procedure

global procedure AddBlood(integer x, integer y)
  atom h
  integer i
  x += rand(3)
  x += rand(3)
  h = new_command(mix_copy, sprites[blood][1], {action_vs,x,y,2})
  set_mixtable(h,FAIR_MIX)
  i = find(0,effects)
  if i then
    effects[i] = {x, y, blood, h, BLOOD,0}
  else
    effects &= {{x,y,blood,h,BLOOD,0}}
  end if
end procedure

procedure ChkLife()
  if Hlife > MAXLIFE then
    Hlife = MAXLIFE
  end if
  text_line({1,1}, back_vs, sprintf("%3d",Hlife))
end procedure

procedure ChkAmmo(integer a)
  integer i
  if ammo[a] > MAX[a] then
    ammo[a] = MAX[a]
  end if
  if a = GUN then
    i = 181
  elsif a = SHOTGUN then
    i = 189
  elsif a = TOMMYGUN then
    i = 197
  elsif a = RPG then
    i = 205
  elsif a = STINGER then
    i = 213
  end if
  text_line({1,i}, back_vs, sprintf("%2d",ammo[a]))
end procedure

integer active

function GetGoodie(integer kind)
  sequence s
  if kind = whisky and Hlife < MAXLIFE then
    Hlife += WHISKYLIFE
    ChkLife()
  elsif kind = medikit and Hlife < MAXLIFE then
    Hlife += MEDIKITLIFE
    ChkLife()
  elsif kind = pizza and Hlife < MAXLIFE then
    Hlife += PIZZALIFE
    ChkLife()
  elsif kind = bluekey then
    keys[BLUEKEY] = 1
  elsif kind = redkey then
    keys[REDKEY] = 1
  elsif kind = yellowkey then
    keys[YELLOWKEY] = 1
  elsif kind = shotgun and (ammo[SHOTGUN] < MAX[SHOTGUN] or
                            not weapon[SHOTGUN]) then
    if not weapon[SHOTGUN] then
      weapon[SHOTGUN] = 1
      Hfirearm = SHOTGUN
    end if
    ammo[SHOTGUN] += ADD[SHOTGUN]
    ChkAmmo(SHOTGUN)
  elsif kind = gunammo and ammo[GUN] < MAX[GUN] then
    ammo[GUN] += ADD[GUN]
    ChkAmmo(GUN)
  elsif kind = shotgunammo and ammo[SHOTGUN] < MAX[SHOTGUN] then
    ammo[SHOTGUN] += ADD[SHOTGUN]
    ChkAmmo(SHOTGUN)
  elsif kind = tommygunammo and ammo[TOMMYGUN] < MAX[TOMMYGUN] then
    ammo[TOMMYGUN] += ADD[TOMMYGUN]
    ChkAmmo(TOMMYGUN)
  elsif kind = rpgammo and ammo[RPG] < MAX[RPG] then
    ammo[RPG] += ADD[RPG]
    ChkAmmo(RPG)
  elsif kind = stingerammo and ammo[STINGER] < MAX[STINGER] then
    ammo[STINGER] += ADD[STINGER]
    ChkAmmo(STINGER)
  elsif kind = presspad then
    s = BUTTON_ADD[effects[active][TAG]]
    Pressing(s)
  elsif kind = button and PUSHING then
    s = BUTTON_ADD[effects[active][TAG]]
    Pressing(s)
    effects[active][STATUS] = STATIC
    set_source_handle(effects[active][HANDLE],
       sprites[button][effects[active][FACING]][9])
    return 1
  elsif kind = eol then
    levelclear = 1
  else
    return 1
  end if
  return 0
end function

global procedure DoEffects()
  integer kind, status, ax, ay, animate, flag
  atom x,y

  for c = 1 to length(effects) do
    if sequence(effects[c]) then
      status = effects[c][STATUS]
      kind = effects[c][KIND]
      x = effects[c][XPOS]
      y = effects[c][YPOS]

      if status = STATIC then
        set_dest_pos(effects[c][HANDLE], {x - scrollx, y - scrolly})

      elsif status = BLOOD then
        animate = effects[c][ALT_ANIM]
        if kind = blood then
          if animate = 8 then
            AddStains(x,y,sprites[kind][8+rand(5)],FAIR_MIX)
            free_command(effects[c][HANDLE])
            effects[c] = 0
          else
            animate += 1
            set_source_handle(effects[c][HANDLE],
                              sprites[kind][animate])
            effects[c][ALT_ANIM] = animate
            set_dest_pos(effects[c][HANDLE],
                      {x-scrollx, y-scrolly})
          end if
        else
          animate += 1
          if animate = length(sprites[kind]) then
            AddStains(effects[c][XPOS],effects[c][YPOS],
                    sprites[kind][animate],DOMINANT_MIX)
            free_command(effects[c][HANDLE])
            effects[c] = 0
          else
            set_source_handle(effects[c][HANDLE], sprites[kind][animate])
            effects[c][ALT_ANIM] = animate
            set_dest_pos(effects[c][HANDLE], {x-scrollx, y-scrolly})
          end if
        end if

      elsif status = GOODIE then

        flag = 1

        if kind = button then
          if effects[c][ANIMATE] = 8 then
            effects[c][ANIMATE] = 1
          else
            effects[c][ANIMATE] += 1
          end if
          set_source_handle(effects[c][HANDLE],
              sprites[button][effects[c][FACING]][effects[c][ANIMATE]])
        end if

        if x <= Hxpos + 17 and
           Hxpos <= x + sizes[kind][XPOS] and
           y <= Hypos + 17 and
           Hypos <= y + sizes[kind][YPOS] then
          active = c
          flag = GetGoodie(kind)
        end if

        if flag then
          set_dest_pos(effects[c][HANDLE], {x-scrollx,y-scrolly})
        else
          free_command(effects[c][HANDLE])
          effects[c] = 0
        end if

      elsif kind = explosion then
        animate = effects[c][ALT_ANIM]

        if animate = 22 then
          free_command(effects[c][HANDLE])
          effects[c] = 0
        else
          if status = MOVING then
            effects[c][XPOS] += effects[c][7]
            effects[c][YPOS] += effects[c][8]
            x = floor(effects[c][XPOS])
            y = floor(effects[c][YPOS])
          elsif animate = 15 then
            AddStains(x,y,sprites[ashes],RECESSIVE_MIX)
          end if
          animate += 1
          if Hxpos <= x + 25 and
           x <= Hxpos + 17 and
           Hypos <= y + 25 and
           y <= Hypos + 17 then
            Hlife -= 1
            text_line({1,1}, back_vs, sprintf("%3d",Hlife))
          end if
          for i = 1 to length(actors) do
            if sequence(actors[i]) then
              ax = floor(actors[i][XPOS])
              ay = floor(actors[i][YPOS])
              if ax <= x + 25 and
               x <= ax + sizes[ actors[i][KIND] ][XPOS] and
               ay <= y + 25 and
               y <= ay + sizes[ actors[i][KIND] ][YPOS] then
                actors[i][LIFE] -= 1
              end if
            end if
          end for
          set_source_handle(effects[c][HANDLE], sprites[explosion][animate])
          effects[c][ALT_ANIM] = animate
          set_dest_pos(effects[c][HANDLE], {x-scrollx, y-scrolly})
        end if
      end if
    end if
  end for
end procedure