procedure OneBullet(sequence s)
  integer i
  atom h

  h = new_command(clear_copy, sprites[bullet], {action_vs, 0, 0, 3})
  s[4] = h


  i = find(0,shots) -- search for 'null-bullets'
  if i then
    shots[i] = s -- should be faster...
  else
    shots = append(shots, s) -- ...than this
  end if

end procedure

procedure AddBulletH()
  sequence s
  
  s = {Hxpos + hayesgunvector[Hfacing][XPOS], -- bullet starting pos
       Hypos + hayesgunvector[Hfacing][YPOS],
       bullet, -- sprite type
       0, -- handle
       vector4[Hfacing][XPOS], -- bullet vector
       vector4[Hfacing][YPOS],
       HAYES} -- bullet fired by

  if Hfirearm = SHOTGUN then
    s[1..2] = {Hxpos,Hypos} + gruntvector[Hfacing]
    for n = 1 to 5 do
      s[5..6] = shotgunvector[Hfacing][n]
      OneBullet(s)
    end for
  elsif Hfirearm = TOMMYGUN then
    s[1..2] = {Hxpos,Hypos} + gruntvector[Hfacing]
    OneBullet(s)
  else
    OneBullet(s)
  end if

end procedure

sequence
  input

integer
  change,
  move,
  right,
  left,
  forward,
  backup,
  fire,
  shift,
  alt

atom
  xvector,
  yvector

while 1 do
  input = get_keys()
  move = 0
  change = 0
  fire = 0

  if Hdelay < 200 then -- avoid program crash because of type fault
    Hdelay += 1
  end if

  if Hroll then
    if Hroll = ROLL_LEFT then
      Hanimate -= 1
      move = 1
      xvector = roll_left_vector[Hfacing][XPOS]
      yvector = roll_left_vector[Hfacing][YPOS]
    else
      Hanimate += 1
      move = 1
      xvector = roll_right_vector[Hfacing][XPOS]
      yvector = roll_right_vector[Hfacing][YPOS]
    end if
    if not Hanimate or Hanimate = 19 then
      Hroll = 0
      Hanimate = 1
      set_source_handle(Hhandle,hayes[Hfirearm][Hfacing][Hanimate])
    else
      set_source_handle(Hhandle,hayes[ROLL][Hfacing][Hanimate])
    end if
  else
    if length(input) then
      left = find(LEFT, input)
      right = find(RIGHT, input)
      forward = find(UP, input)
      backup = find(DOWN, input)
      fire = find(LEFT_CTRL, input) or find(RIGHT_CTRL, input)
      shift = find(LEFT_SHIFT, input) or find(RIGHT_SHIFT, input)
      alt = find(LEFT_ALT, input) or find(RIGHT_ALT, input)
      PUSHING = find(SPACE, input)
      if find(ESCAPE, input) then
        if graphics_mode(-1) then end if
        abort(0)
      end if
      if alt and left and Hfirearm < RPG then
        Hroll = ROLL_LEFT
        Hanimate = 19
      elsif alt and right and Hfirearm < RPG then
        Hroll = ROLL_RIGHT
        Hanimate = 0
      elsif shift and left then
        change = 1
        move = 1
        if forward then
          xvector = step_left_vector[Hfacing+3][XPOS]
          yvector = step_left_vector[Hfacing+3][YPOS]
        elsif backup then
          xvector = step_left_vector[Hfacing+21][XPOS]
          yvector = step_left_vector[Hfacing+21][YPOS]
        else
          xvector = step_left_vector[Hfacing][XPOS]
          yvector = step_left_vector[Hfacing][YPOS]
        end if
      elsif shift and right then
        change = 1
        move = 1
        if forward then
          xvector = step_right_vector[Hfacing+21][XPOS]
          yvector = step_right_vector[Hfacing+21][YPOS]
        elsif backup then
          xvector = step_right_vector[Hfacing+3][XPOS]
          yvector = step_right_vector[Hfacing+3][YPOS]
        else
          xvector = step_right_vector[Hfacing][XPOS]
          yvector = step_right_vector[Hfacing][YPOS]
        end if
      else
        if find(ONE, input) then
          if weapon[GUN] then
            change = 1
            Hfirearm = GUN
          end if
        elsif find(TWO, input) then
          if weapon[SHOTGUN] then
            change = 1
            Hfirearm = SHOTGUN
          end if
        elsif find(THREE, input) then
          if weapon[TOMMYGUN] then
            change = 1
            Hfirearm = TOMMYGUN
          end if
        elsif find(FOUR, input) then
          if weapon[RPG] then
            change = 1
            Hfirearm = RPG
          end if
        elsif find(FIVE, input) then
          if weapon[STINGER] then
            change = 1
            Hfirearm = STINGER
          end if
        end if
        if left then
          if Hturn = 1 then
            change = 1
            Hturn = 3
            if Hfacing = 1 then
              Hfacing = 24
            else
              Hfacing -= 1
            end if
          else
            Hturn -= 1
          end if
        elsif right then
          if Hturn = 3 then
            change = 1
            Hturn = 1
            if Hfacing = 24 then
              Hfacing = 1
            else
              Hfacing += 1
            end if
          else
            Hturn += 1
          end if
        end if

        if forward then
          move = 1
          change = 1
          xvector = vector2[Hfacing][XPOS]
          yvector = vector2[Hfacing][YPOS]
        elsif backup then
          move = 1
          change = 1
          xvector = backvector[Hfacing][XPOS]
          yvector = backvector[Hfacing][YPOS]
        end if
      end if
    end if

    if move then
      if Hanimate = 16 then
        Hanimate = 1
      else
        Hanimate += 1
      end if
    end if

    if change then
      set_source_handle(Hhandle,hayes[Hfirearm][Hfacing][Hanimate])
    end if
  
  end if
  
  if move then
    Hx += xvector
    Hy += yvector
    Hxpos = floor(Hx)
    Hypos = floor(Hy)

    if Wall(Hxpos, Hypos, 17, walkover)
      or Actor(Hxpos, Hypos, 17, HAYES)
      or DoorH()
    then
      Hx -= xvector
      Hxpos = floor(Hx)
      if Wall(Hxpos, Hypos, 17, walkover)
        or Actor(Hxpos, Hypos, 17, HAYES)
        or DoorH()
      then
        Hx += xvector
        Hxpos = floor(Hx)
        Hy -= yvector
        Hypos = floor(Hy)
        if Wall(Hxpos, Hypos, 17, walkover)
          or Actor(Hxpos, Hypos, 17, HAYES)
          or DoorH()
        then
          Hx -= xvector
          Hxpos = floor(Hx)
        end if
      end if
    end if
  end if
  
  if fire then
    if Hdelay > ROF[Hfirearm] and ammo[Hfirearm] then
      ammo[Hfirearm] -= 1
      text_line({1,173+Hfirearm*8}, back_vs, sprintf("%2d",ammo[Hfirearm])) -- extra
      Hdelay = 0
      AddBulletH()
    end if
  end if
  
  if Hxpos - scrollx < 90 then
    scrollx = Hxpos - 90
    if scrollx < 0 then
      scrollx = 0
    end if
  elsif Hxpos - scrollx > 130 then
    scrollx = Hxpos - 130
    if scrollx > maxscrollx then
      scrollx = maxscrollx
    end if
  end if
  if Hypos - scrolly < 90 then
    scrolly = Hypos - 90
    if scrolly < 0 then
      scrolly = 0
    end if
  elsif Hypos - scrolly > 130 then
    scrolly = Hypos - 130
    if scrolly > maxscrolly then
      scrolly = maxscrolly
    end if
  end if

--if integer(Hdelay/3) then
--  AddExplosion(198,278,shotgunvector[rand(3)][rand(5)]/4*5)
--  h = new_command(clear_copy, {vs,0,0,4,4,-1,-1}, {action_vs,0,0,3})
--  shots = append(shots,{200,280,grenade,new_command(clear_copy, sprites[grenade], {action_vs,0,0,3}) } & shotgunvector[rand(3)][rand(5)]/4*5 & {1,50+rand(50)})
--end if

  MoveActors()
  MoveShots()
  DoObs()
  DoEffects()

  set_dest_pos(Hhandle, {Hxpos - scrollx, Hypos - scrolly})
  set_source_pos(levelsrc, {scrollx, scrolly})
  flip()
  ClearStains()

  if levelclear then
    ClearUp()
    currentlevel += 1
    LoadLevel()
  elsif Hlife < 1 then
    if graphics_mode(2) then end if
    puts(1,"You withered and died!\n")
    abort(0)
  end if

end while

