integer drf
object karar
constant CARRIERS = {28,29,30,31,32,33,34,35,36,37,46,47,48}
constant CARRYSTUFF = {58,59,60,63,64,65,66}

global procedure Pressing(sequence s)
  sequence carry
  carry = {}
  for i = 1 to length(s) do
	if s[i][1] = 2 and find(s[i][4], CARRYSTUFF) then
	  carry = append(carry, s[i][2..4])
	else
	  GetActors(s[i])
	end if
	if sequence(s[i][4]) then
	  if find(s[i][4][1], CARRIERS) then
		for n = 1 to length(carry) do
		  if equal(carry[n][1..2],s[i][2..3]) then
			actors[length(actors)][CARRY] = carry[n][3]
		  end if
		end for
	  end if
	end if
  end for
end procedure

drf = open("lvl\\chap1.lvl","rb")
karar = bget(drf)
constant LEVELS = karar[2][2]

sequence void

procedure LoadBar()
  sequence s
  atom vs
  vs = virtual_screen(40,240)
  s = load_sprites("gfx\\bar2.gfx")
  select_dest(vs)
  display_image({0,0},s[1][1])
  bar = allocate_source({vs,0,0,40,240})
end procedure

function LoadTileSet(sequence filename, integer flag)
  sequence tiles
  atom vs
  tiles = load_sprites(filename)
  tiles = tiles[1]
  if flag then
	tiles[1] *= 0
	tiles[1] += 1
  end if
  vs = virtual_screen(length(tiles)*20,20)
  select_dest(vs)
  for c = 0 to length(tiles) - 1 do
	display_image({c*20,0},tiles[c+1])
  end for
  return vs
end function

procedure MakeLevel(sequence l)
  level = l[1]
  BUTTON_ADD = l[2]
  void = level[2..4] & {{}}
  level = level[1]
  levelvs = virtual_screen(length(level[1])*20,length(level)*20)
  levelsrc = allocate_source({levelvs,0,0,240,240})
  maxscrollx = length(level[1])*20-240
  maxscrolly = length(level)*20-240
  levelcopy = new_command(copy, levelsrc,{action_vs,0,0,0})
  LVL_FLY = level > flyover      -- note the difference
  LVL_WALK = level <= walkover   -- between these two

  for n = 1 to length(LVL_WALK) do
	LVL_WALK[n] &= 0
  end for
  LVL_WALK = append(LVL_WALK,LVL_WALK[1] * 0)

  for y = 1 to length(level) do
	for x = 1 to length(level[y]) do
	  GetActors({1,x,y,level[y][x]})
	  if find(void[1][y][x],CARRYSTUFF) then
		void[4] = append(void[4],{x,y,void[1][y][x]})
	  elsif void[1][y][x] then
		GetActors({2,x,y,void[1][y][x]})
	  end if
	end for
  end for

end procedure

procedure InitModeX()
  integer f
  sequence p
  init_text(90,157)
  if mode_x(320,240) then
	puts(1,"Loser!")
	abort(1)
  end if
  
  f = open("data\\pal.dat","rb")
  p = bget(f)
  close(f)
  all_palette(p[2])
  border_color(1)

  tick_rate(300)
  flip_setup(flip_page,screen,30)
  back_vs = virtual_screen(320,240)
  action_vs = sub_screen(back_vs,240,240,{40,0})
  last_copy = new_command(copy, {back_vs,0,0,320,240}, {flip_vs,0,0,7})
  do_command(copy,bar,{back_vs,0,0})
  do_command(copy,bar,{back_vs,280,0})
  select_dest(back_vs)
  text_line({1,1}, back_vs, "300")
  text_line({1,181}, back_vs, " 0/99") -- extra
  text_line({1,189}, back_vs, "  /30") -- extra
  text_line({1,197}, back_vs, "  /99") -- gun
  text_line({1,205}, back_vs, "  /50") -- shotgun
  text_line({1,213}, back_vs, "  /99") -- tommygun
  text_line({1,221}, back_vs, "  /30") -- rpg
  text_line({1,229}, back_vs, "  /99") -- stinger
end procedure

function LoadMovingSprite(sequence filename, sequence frames, object flag)
  integer atx, aty, i, hor, ver, noi
  sequence images, hotspots, s1, s2
  atom vs
  images = load_sprites("gfx\\"&filename)
  printf(1,"%s\n",{filename})

  hotspots = images[2]
  images = images[1]
  hor = 0 ver = 0
  for c = 1 to length(images) do
	if length(images[c]) > ver then
	  ver = length(images[c])
	end if
	if length(images[c][1]) > hor then
	  hor = length(images[c][1])
	end if
  end for
  noi = length(images)/24
  vs = virtual_screen(hor*noi,ver*24)
  select_dest(vs)
  atx = 0
  i = 0
  s1 = repeat({},24)
  for x = 1 to noi do
	aty = 0
	for c = 1 to 24 do
	  i = i + 1
	  display_image({atx,aty},images[i])
	  s1[c] = append(s1[c], allocate_source({vs, atx, aty, length(images[i][1]), length(images[i]), -hotspots[i][1], -hotspots[i][2]}))
	  aty = aty + ver
	end for
	atx = atx + hor
  end for
  s2 = repeat({},24)
  for x = 1 to 24 do
	for y = 1 to length(frames) do
	  s2[x] = append(s2[x],s1[x][frames[y]])
	end for
  end for
  if not flag then
	return s2
  else
	sprites = append(sprites, s2)
	sizes = append(sizes, {flag,flag})
	return length(sprites)
  end if
end function

sprites = {}
sizes = {}

function LoadStaticSprite(sequence filename, sequence frames, integer faces)
  integer atx, aty, i, hor, ver, noi
  sequence images, s1, s2
  atom vs
  images = load_sprites("gfx\\"&filename)
  printf(1,"%s\n",{filename})
  images = images[1]
  hor = length(images[1][1])
  ver = length(images[1])
  noi = length(images)/faces
  vs = virtual_screen(hor*noi,ver*faces)
  select_dest(vs)
  aty = 0
  i = 0
  s1 = repeat({},faces)
  for x = 1 to faces do
	atx = 0
	for c = 1 to noi do
	  i = i + 1
	  display_image({atx,aty},images[i])
	  s1[x] = append(s1[x], allocate_source({vs, atx, aty, hor, ver, 0, 0}))
	  atx = atx + hor
	end for
	aty = aty + ver
  end for
  s2 = repeat({},faces)
  for x = 1 to faces do
	for y = 1 to length(frames) do
	  s2[x] = append(s2[x],s1[x][frames[y]])
	end for
  end for
  if faces = 1 then
	s2 = s2[1]
  elsif length(frames) = 1 then
	for c = 1 to faces do
	  s2[c] = s2[c][1]
	end for
  end if
  sprites = append(sprites, s2)
  sizes = append(sizes, {hor,ver})
  return length(sprites)
end function

global function LoadLotsaSprites(sequence filename)
  integer hor, ver, atx
  sequence nums, images
  atom vs
  hor = 0 ver = 0 atx = 0 nums = {}
  images = load_sprites("gfx\\"&filename)
  printf(1,"%s\n",{filename})
  images = images[1]
  for c = 1 to length(images) do
	if length(images[c]) > ver then
	  ver = length(images[c])
	end if
	if length(images[c][1]) > hor then
	  hor = length(images[c][1])
	end if
  end for
  vs = virtual_screen(hor*length(images),ver)
  select_dest(vs)
  for c = 1 to length(images) do
	display_image({atx,0},images[c])
	sizes = append(sizes,{length(images[c][1]),length(images[c])})
	sprites = append(sprites, allocate_source({vs,atx,0,length(images[c][1]),length(images[c])}))
	nums = append(nums, length(sprites))
	atx = atx + hor
  end for
  return nums
end function

constant
  ANIM = {1,1,2,2,3,3,4,4,5,5,4,4,3,3,2,2},
  ANIM2 = {1,1,1,2,2,2,3,3,3,4,4,4,5,5,5,4,4,4,3,3,3,2,2,2},
  ROLL_ANIM = {1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9},
  EXPL_ANIM = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22},
  BREAK_ANIM = {1,1,2,2,3,3,4,4,5,5,6},
  GHOST_ANIM = {1,1,1,2,2,2,3,3,3,4,4,4,5,5,5},
  TORCH_ANIM = {1,1,1,1,2,2,2,2,3,3,3,3,2,2,2,2},
  ANIM_HALF = {1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,3,3,3,3,2,2,2,2}

function GetMixTable(sequence file)
  atom adr, at
  integer f
  adr = allocate(256*256)
  f = open(file,"rb")
  at = adr
  for c = 1 to 256*256 do
	poke(at,getc(f))
	at += 1
  end for
  return adr
end function

function FreeSeq(sequence s)
  for n = 1 to length(s) do
	if sequence(s[n]) then
	  free_command(s[n][HANDLE])
	end if
  end for
  return {}
end function

global procedure ClearUp()
  shots = FreeSeq(shots)
  actors = FreeSeq(actors)
  obs = FreeSeq(obs)
  effects = FreeSeq(effects)
  free(levelvs)
  free(levelsrc)
  free_command(levelcopy)
  free_command(Hhandle)
  levelclear = 0
  keys *= 0
end procedure

global procedure LoadLevel()
  MakeLevel(LEVELS[currentlevel])  
  for y = 1 to length(void[2]) do
	for x = 1 to length(void[2][y]) do
	  if sequence(void[2][y][x]) then
		GetActors({3,x,y,void[2][y][x]})
		if find(void[2][y][x][1], CARRIERS) then
		  for n = 1 to length(void[4]) do
			if equal(void[4][n][1..2],{x,y}) then
			  actors[length(actors)][CARRY] = void[4][n][3]
			end if
		  end for
		end if
	  end if
	  if void[3][y][x] then
		GetActors({4,x,y,void[3][y][x]})
	  end if
	end for
  end for
  scrollx = 0
  scrolly = 0
end procedure

without warning

global procedure InitGame()
  sequence s
  if graphics_mode(2) then
	puts(1,"You sure got some wierd graphics-card.\n")
  end if
  ?time()
  puts(1,"Loading grafix:\n")
  tv = LoadStaticSprite("tv.gfx",{1,1,2,2,3,3},4)
  pc = LoadStaticSprite("pc.gfx",{1,1,2,2,3,3},4)
  chair = LoadStaticSprite("chair.gfx",{1},8)
  locker = LoadStaticSprite("locker.gfx",{1},4)
  washbasin = LoadStaticSprite("wash.gfx",{1},4)
  toilet = LoadStaticSprite("toilet.gfx",{1},4)
  light = LoadStaticSprite("light.gfx",{1},43)
  bottle = LoadStaticSprite("bottles.gfx",{1},10)
  car = LoadStaticSprite("car.gfx",{1},3)

  windowhorbreak = LoadStaticSprite("hglass.gfx",BREAK_ANIM,1)
  windowverbreak = LoadStaticSprite("vglass.gfx",BREAK_ANIM,1)
  breakwood = LoadStaticSprite("diewood.gfx",BREAK_ANIM,1)
  breakmetal = LoadStaticSprite("diemetal.gfx",BREAK_ANIM,1)

  torch = LoadStaticSprite("torch.gfx",TORCH_ANIM,1)
  button = LoadStaticSprite("button.gfx",{1,1,1,1,2,2,2,2,3},4)
  s = LoadLotsaSprites("statics.gfx")
  bluekey = s[1]
  redkey = s[2]
  yellowkey = s[3]
  opendoorhor = s[4]
  opendoorver = s[5]
  bluedoorhor = s[6]
  bluedoorver = s[7]
  reddoorhor = s[8]
  reddoorver = s[9]
  yellowdoorhor = s[10]
  yellowdoorver = s[11]
  windowhor = s[12]
  windowver = s[13]
  eol = s[14]
  whisky = s[15]
  medikit = s[16]
  pizza = s[17]
  gunammo = s[18]
  shotgunammo = s[19]
  tommygunammo = s[20]
  rpgammo = s[21]
  stingerammo = s[22]
  barrel = s[23]
  ashes = s[24]
  plant = s[25]
  gun = s[26]
  shotgun = s[27]
  presspad = s[28] -- 20*20 image, color 0
  explosion = LoadStaticSprite("explode.gfx",EXPL_ANIM,1)
  blood = LoadStaticSprite("blood.gfx",ANIM[1..9]&{6,7,8,9},1)
  sitter = LoadMovingSprite("sitter.gfx",{1}, 20)
  grunt = LoadMovingSprite("grunt.gfx",ANIM & ANIM, 18)
  thug = LoadMovingSprite("thug.gfx",ANIM2 & ANIM2, 18)
  dame = LoadMovingSprite("dame.gfx",ANIM2 & ANIM2, 16)
  ghost = LoadMovingSprite("ghost.gfx",GHOST_ANIM,21)
  undead = LoadMovingSprite("undead.gfx", ANIM2, 16)
  halfdead = LoadMovingSprite("halfdead.gfx", ANIM_HALF, 16)
--  guntower = LoadMovingSprite("guntower.gfx", GHOST_ANIM & {6,6,6},20)
--  gangster = LoadMovingSprite("gangster.gfx", ANIM2, 18)
  gangster = 0 guntower = 0
  hayes = repeat(0,11)
  hayes[GUN] = LoadMovingSprite("HGUN.gfx",ANIM, HAYES)
  hayes[SHOTGUN] = LoadMovingSprite("hshotgun.gfx", ANIM, HAYES)
--  hayes[TOMMYGUN] = LoadMovingSprite("htommy.gfx", ANIM, HAYES)
--  hayes[RPG] = LoadMovingSprite("hrpg.gfx",ANIM, HAYES)
--  hayes[STINGER] = LoadMovingSprite("hstinger.gfx",ANIM, HAYES)
  hayes[ROLL] = LoadMovingSprite("hroll.gfx",ROLL_ANIM, HAYES)
  ?time()
  obs = {}
  actors = {}
  shots = {}
  stains = {}
  effects = {}
  DOMINANT_MIX = GetMixTable("data\\tabled.dat")
  RECESSIVE_MIX = GetMixTable("data\\tabler.dat")
  FAIR_MIX = GetMixTable("data\\table.dat")
  LoadBar()
  InitModeX()
  levelclear = 0
  currentlevel = 1
  tilevs = LoadTileSet("gfx\\tiles.gfx", 1)
  flavorvs = LoadTileSet("gfx\\1stlayer.gfx", 0)
  scrollx = 0
  scrolly = 0
  LoadLevel()
  Hanimate = 1
  Hturn = 2
  Hroll = 0
  Hlife = 999
  Hdelay = 0
  weapon = {1,0,0,0,0}
  ammo = {0,0,0,0,0}
  keys = {0,0,0}
  Hfirearm = GUN
  sizes -= 1
  BLEEDERS = {thug,grunt,sitter,ghost,dame,gangster,undead,halfdead}
end procedure

