procedure TempSetUp()
  atom vs, h
  grenade = 1
  vs = virtual_screen(4,4)
  select_dest(vs)
  display_image({0,0}, {{00,30,30,00},
                        {30,30,30,30},
                        {30,30,30,30},
                        {00,30,30,00}})
  sprites = append(sprites, allocate_source({vs,0,0,4,4,-1,-1}))
  grenade = length(sprites)

  vs = virtual_screen(3,3)
  select_dest(vs)
  display_image({0,0}, {{00,30,00},
                        {30,30,30},
                        {00,30,00}})
  

  sprites = append(sprites, allocate_source({vs,0,0,3,3,-1,-1}))
  bullet = length(sprites)
--  h = new_command(clear_copy, {vs,0,0,4,4,-1,-1}, {action_vs,0,0,3})
--  shots = {{20,40,grenade,h,3,1,100}}
end procedure

TempSetUp()

global procedure DoObs()
  integer kind

  for c = 1 to length(obs) do
    if sequence(obs[c]) then
      if obs[c][STATUS] = STATIC_ANIMATE then
        kind = obs[c][KIND]
        if obs[c][ALT_ANIM] = length(sprites[kind]) then
          obs[c][ALT_ANIM] = 1
        else
          obs[c][ALT_ANIM] += 1
        end if
        set_source_handle(obs[c][HANDLE],
                          sprites[kind][obs[c][ALT_ANIM]])
      end if
      set_dest_pos(obs[c][HANDLE], {obs[c][XPOS]-scrollx,
                                      obs[c][YPOS]-scrolly})
    end if
  end for
end procedure

sequence v

procedure InsertShot(sequence xy, integer i)
  sequence s
  atom h
  h = new_command(clear_copy, sprites[bullet], {action_vs, 0, 0, 3})
  s = {actors[i][XPOS] + v[XPOS], -- bullet starting pos
       actors[i][YPOS] + v[YPOS],
       bullet, -- sprite type
       h, -- handle
       xy[XPOS], -- bullet vector
       xy[YPOS],
       i}
  i = find(0,shots) -- search for 'null-bullets'
  if i then
    shots[i] = s -- should be faster...
  else
    shots = append(shots, s) -- ...than this
  end if
end procedure

global procedure AddBullet(integer i)
  integer x

  if actors[i][KIND] = sitter then
    if rand(2) = 1 then
      v = sitter_leftbullet_vector[actors[i][FACING]]
    else
      v = sitter_rightbullet_vector[actors[i][FACING]]
    end if
    InsertShot(vector4[actors[i][FACING]],i)

  elsif actors[i][KIND] = grunt then
    v = gruntvector[actors[i][FACING]]
    for n = 1 to 5 do
      InsertShot(shotgunvector[actors[i][FACING]][n],i)
    end for

  elsif actors[i][KIND] = guntower then
    if actors[i][ANIMATE] = 18 then
      v = towerleftvector[actors[i][FACING]]
    else
      v = towerrightvector[actors[i][FACING]]
    end if
    InsertShot(vector4[actors[i][FACING]],i)
  
  elsif actors[i][KIND] = thug then
    v = thugvector[actors[i][FACING]]
    InsertShot(vector4[actors[i][FACING]],i)

  elsif actors[i][KIND] = dame then
    v = sitter_leftbullet_vector[actors[i][FACING]]
    InsertShot(vector4[actors[i][FACING]],i)
    v = sitter_rightbullet_vector[actors[i][FACING]]
    InsertShot(vector4[actors[i][FACING]],i)

  elsif actors[i][KIND] = gangster then
    if actors[i][ANIMATE] = 24 then
      x = 1
    elsif actors[i][ANIMATE] = 5 then
      x = 3
    elsif actors[i][ANIMATE] = 10 then
      x = 5
    elsif actors[i][ANIMATE] = 15 then
      x = 4
    elsif actors[i][ANIMATE] = 20 then
      x = 2
    end if
    v = gangstervector[actors[i][FACING]]
    InsertShot(tommygunvector[actors[i][FACING]][x], i)

  end if
end procedure

global procedure MoveShots()
  integer kind, hit, inair, who
  atom xvector, yvector, xpos, ypos, handle
  object s
  for c = 1 to length(shots) do
    if sequence(shots[c]) then
      s = shots[c]
      kind = s[KIND]
      xpos = s[XPOS]
      ypos = s[YPOS]
      handle = s[HANDLE]
      xvector = s[XVECTOR]
      yvector = s[YVECTOR]
      if kind = bullet then
        who = s[WHO]
        xpos = xpos + xvector
        ypos = ypos + yvector
        if HitSome(xpos, ypos, who, flyover) then
          s = 0
        else
          s[XPOS] = xpos
          s[YPOS] = ypos
        end if
      elsif kind = grenade then
--        inair = s[INAIR]
        s[INAIR] -= 1
--      inair = 2
        if not s[INAIR] then
          AddExplosion(xpos-11,ypos-11,s[XVECTOR..YVECTOR])
          s = 0
--          s[XVECTOR] = 0
--          s[YVECTOR] = 0
        else
--          s[INAIR] = inair - 1
          xpos = xpos + xvector
          ypos = ypos + yvector
          hit = Wall(xpos, ypos, 1, flyover) or Door(xpos, ypos, 1)
          if hit then
            xpos = xpos - xvector
            hit = Wall(xpos, ypos, 1, flyover) or Door(xpos, ypos, 1)
            if not hit then
              s[XVECTOR] = -xvector
              s[YPOS] = ypos
            else
              xpos = xpos + xvector
              ypos = ypos - yvector
              hit = Wall(xpos, ypos, 1, flyover) or Door(xpos, ypos, 1)
              if not hit then
                s[YVECTOR] = -yvector
                s[XPOS] = xpos
              else
                ypos = ypos - yvector
                s[YVECTOR] = -yvector
                s[XVECTOR] = -xvector
              end if
            end if
          else
            s[XPOS] = xpos
            s[YPOS] = ypos
          end if
        end if
      end if
      if atom(s) then
        free_command(handle)
      else
        set_dest_pos(handle, {xpos - scrollx, ypos - scrolly})
      end if
      shots[c] = s
    end if
  end for
end procedure

